#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <dos.h>
#include <dir.h>
#include <bios.h>
#include <ctype.h>
#include <io.h>
#include <process.h>
#include <fcntl.h>
#include <sys\stat.h>

// compile it in Compact model !

typedef short int uint; // must be unsigned also, but NOT 32-bit
typedef unsigned long ulong;
typedef unsigned char uchar;


int in;     // input file handle
ulong   file_len;
char far *saveDTA;
char newDTA[512];

// filename to find in some archive, may contain * and ?
uchar ffilename[120];

// filename of base of previously scanned files (must be exported first)
char bfilename[120];
// flags that allow the exporting of current filebase
int import_f=0, export_f=0;

// dos command to run with archive, may contain %FNAME
uchar ccommand[120];

// current archive full filename (with path)
char fname[120];
char curdir[120];
int curdirend=0; // end of line index

// only filename, no path, no extension
char oname[120];

int no_mkdir=0; // don't create dir even if %NAME was used in DOS cmd
int mk_sort_list=0; // should we create sorted filelist ?

// how to handle an archive content
#define SEARCH 0
#define COLLECT 1

ulong flen( int f )   // return file size
{
    ulong len; len=lseek( f, 0, 2); lseek( f, 0, 0); return len;
}


#define uppdcrc(_crc,_c) _crc=(crctab[((int)(_crc)^(_c))&0xff]^((_crc)>>8))
#define CRCMASK		0xffffffffUL
#define CRCP		0xEDB88320UL

ulong crc, crctab[256];

static void makecrctab(void) {

    uint i,j;
    ulong tv;

    for (i=0;i<256;i++) {
	tv=i;
	for (j=8;j>0;j--) {
	    if (tv&1) tv=(tv>>1)^CRCP;
	    else tv>>=1;
	}
	crctab[i]=tv;
    }
}

// return true if Ok
int get_file_crc( char *name, long len, long *ocrc )
{
   uchar c;
   int r;
   crc=CRCMASK;
   FILE *in;

   if ((in=fopen( name, "rb" )) == NULL) return 0;

   while (len-- > 0)
   {
     r=fgetc(in);
     if ( r == EOF )
     {
        fclose(in); return 0;
     }
     c=r;
     uppdcrc(crc, c );
   }
   fclose(in);
   *ocrc = ( crc^CRCMASK );
   return 1;
}

// ࠢ  ப  ⮬ ᯥᨬ
// 1 ᫨ ᯥ譮 ࠢ
int xstrcmp( uchar far *str, uchar far *templ )
{
   uint i,k;
   while ( *templ ) //  ᥩ  ࠧ
   {
      switch ( *templ )
      {
        case '?': if (*str) break; //   ᨬ
                  else      return 0;
        case '*':
            if ( *(templ+1) == 0) return 1; // ᫨ ࠧ 稢 '*'
                                            //  ப 室 
            for ( k=0; k<16; k++ ) //    ᫥騩 ᨬ
               if ( *(templ+1) == *(str+k) )
               {
                  templ++; str += k; goto a;
               } else if (*(str+k)==0) break;
            return 0; //  ᮢ
        default :
            if ( toupper( *str ) != toupper( *templ )) return 0;
      }
      templ++; str++;
     a:
   };
   if (*str == 0) return 1; // ࠢ ᯥ譮
   else           return 0;
};

// adds an point (dot) to a filename, if there wasn't one
char far *add_pt(char *s)
{
   static char z[120];
   char *t;
   int was_pt=0;
   t = z;
   while ( *s )
   {
      *t++ = *s++; if (*(s-1) == '.') was_pt=1;
   }
   if ( was_pt ) *t=0; else { *t++ = '.'; *t=0; }
   return z;
}

// return 1 if compared Ok
int is_name( char *name)
{
   if ( !stricmp( name, ffilename)) return 1; // compared exactly
   return xstrcmp( add_pt(name), ffilename); // regular expression comapison
}

#define MAX_ARCS 2048
typedef char far * LPSTR;
// array of pointers to archive names
LPSTR *arcnames;
int arccount=0;

int arcname; // index of current archive name in arcnames[]


// text output of sorted list
void report(void);


int add_arcname(char *name)
{
   if ( arccount==MAX_ARCS )
   {
      printf("error: maximum of %d archives per list reached\n",
      MAX_ARCS );
      report();
      exit(0);
   }
   arcnames[arccount]=strdup(name);
   if ( arcnames[arccount++]==NULL )
   {
      printf("error: name of archive %s cannot be stored\n",
      name );
      report();
      exit(0);
   }
   return arccount-1;
}

typedef struct
{
   int  arcname; // index of archive name in names list
   long decomp_size, crc;
   int  flag;
   char name[1]; // if strlen() returns 0, name is "\0"
} ITEM;

#define MAX_FILS (4096+4096+4096)
int icount=0;
ITEM *item[MAX_FILS]; // array of pointers to ITEM's

// compares two files in two archives
int sort_function( const void *a, const void *b)
{
   ITEM *c, *d;
   c = *((ITEM **)a);
   d = *((ITEM **)b);
   if (((ITEM *)c)->decomp_size >
       ((ITEM *)d)->decomp_size ) return 1;
   if (((ITEM *)c)->decomp_size <
       ((ITEM *)d)->decomp_size ) return -1;

   if (((ITEM *)c)->crc >
       ((ITEM *)d)->crc ) return 1;
   if (((ITEM *)c)->crc <
       ((ITEM *)d)->crc ) return -1;

   if (((ITEM *)c)->arcname >
       ((ITEM *)d)->arcname ) return 1;
   if (((ITEM *)c)->arcname <
       ((ITEM *)d)->arcname ) return -1;

   return 0;
}

// compares two files in two archives (names reversed)
int sort_functionA( const void *a, const void *b)
{
   ITEM *c, *d;
   c = *((ITEM **)a);
   d = *((ITEM **)b);
   if (((ITEM *)c)->decomp_size >
       ((ITEM *)d)->decomp_size ) return 1;
   if (((ITEM *)c)->decomp_size <
       ((ITEM *)d)->decomp_size ) return -1;

   if (((ITEM *)c)->crc >
       ((ITEM *)d)->crc ) return 1;
   if (((ITEM *)c)->crc <
       ((ITEM *)d)->crc ) return -1;

   if (((ITEM *)c)->arcname >
       ((ITEM *)d)->arcname ) return -1;
   if (((ITEM *)c)->arcname <
       ((ITEM *)d)->arcname ) return 1;

   return 0;
}

void export(void);

// text output of sorted list
void report(void)
{
   int i;
   char c;

   qsort((void *)item, icount, sizeof(ITEM *), sort_function);

   printf("\nSorted list:\ndecomp.len   CRC-32    filename     arcname\n\n");
   for (i=0; i<icount; i++)
   {
      c=' ';
      item[i]->flag = 0; // file is not marked

      if (i<icount-1)
      if (( item[i]->decomp_size == item[i+1]->decomp_size ) &&
	  ( item[i]->crc == item[i+1]->crc))
      { c='*'; item[i]->flag = 1; } // mark the file

      printf("%c %9ld %08lX %-14s %s\n",
      c, item[i]->decomp_size, item[i]->crc, item[i]->name,
      arcnames[ item[i]->arcname ] );
   }

   printf("\nList of archive(s), that seems to be full duplicated\n"
   "in another archive\n\n");

   for (i=0; i<arccount; i++) // each archive
   {
      int j, all_in_others;

      for (j=0, all_in_others=1; j<icount; j++) // find through all files
      {
         if ( item[j]->arcname != i) continue;
         if ( item[j]->flag ==0) // file is not marked as identical
	    { all_in_others=0;
	      break; }
         if ( stricmp(item[j]->name, item[j+1]->name)) // names don't match
	    { all_in_others=0;
	      break; }
      }
      if (all_in_others)
      printf("%s\n", arcnames[i]);
   }

   // another file order
   qsort((void *)item, icount, sizeof(ITEM *), sort_functionA);
   for (i=0; i<icount; i++)
   {
      item[i]->flag = 0; // file is not marked

      if (i<icount-1)
      if (( item[i]->decomp_size == item[i+1]->decomp_size ) &&
          ( item[i]->crc == item[i+1]->crc))
            item[i]->flag = 1; // mark the file
   }

   printf("\nAlternate sorting results:\n\n");

   for (i=0; i<arccount; i++) // each archive
   {
      int j, all_in_others;

      for (j=0, all_in_others=1; j<icount; j++) // find through all files
      {
         if ( item[j]->arcname != i) continue;
         if ( item[j]->flag ==0) // file is not marked as identical
	    { all_in_others=0;
	      break; }
         if ( stricmp(item[j]->name, item[j+1]->name)) // names don't match
	    { all_in_others=0;
	      break; }
      }
      if (all_in_others)
      printf("%s\n", arcnames[i]);
   }

   if (export_f) export();

}


// adds one file from current archive to sorted list
void add_list( char *name, long decomp_size, long crc )
{
   int len=strlen( name );

   if ( !len ) return; // skip empty entries
   if ( icount==MAX_FILS )
   {
      printf("error: maximum of %d files per list reached\n",
      MAX_FILS );
      report();
      exit(0);
   }
   item[icount]=(ITEM *)farmalloc( sizeof(ITEM) + len);
   if ( item[icount]==(ITEM *)NULL )
   {
      printf("error: file %s (item %d) cannot be stored, no memory available\n",
      name, icount );
      report();
      exit(0);
   }
   memset( item[icount], 0, sizeof(ITEM) + len);
   strcpy( item[icount]->name, name );

   item[icount]->arcname    = arcname; // name of archive
   item[icount]->decomp_size= decomp_size;
   item[icount++]->crc      = crc;

}

//---------------------------- LHA support ---------------------------------

struct
{
  uchar  hdr_len, hdr_csum, method[5];
  ulong  Size_c, Size_o, Date_Time;
  uchar attr, byte, name_len;

  // char name;
  // short Crc16;
  // uint   Filler1;
  // ulong  Filler2;
  // uint   Filler3;
} LHA;

// finds  a contents of .LHA archive
int find_LHA( char * arcName, int add )
{
   long filesize, SavePos;
   int n, k, Done, I; short Crc16;
   static uchar FileName[260+1];
   static uchar Path[260];

   if (add==COLLECT) arcname=add_arcname( fname ); // store name of archive

   if (( in=open( arcName, O_RDONLY | O_BINARY ))<0 )
      return 0;

   filesize=lseek( in, 0, 2 );
   lseek( in, 0, 0 );

   Done = 0;

   while (!Done && lseek( in, 0, 1 ) < filesize )
   {
     SavePos = lseek( in, 0, 1 );
     read( in, &LHA, sizeof(LHA));
     if (!LHA.hdr_len) break;    	// end of archive reached

     read( in, FileName, ((int)LHA.name_len) & 0x00FF );
     FileName[ ((int)LHA.name_len) & 0x00FF ]=0;
     read( in, &Crc16, 2 );     // CRC-16
     read( in, &I, 1 );		// 'M'
     read( in, &k, 2 );         // sizeof( next chunk )
     read( in, &I, 1 );         // 1st char
     if (k>2)
     {
	int pos=0;
	k-=3;                   // sizeof(k) + sizeof((BYTE) 0xFF)
	while (k--)
	{
	    read( in, &Path[pos], 1 );
	    if ((Path[pos] & 0xFF) == 0xFF) Path[pos]='\\';
	    pos++;
	}
	Path[pos]='\0';
     }
     printf( " %s%s\n", Path, FileName );

     lseek(in, SavePos + LHA.hdr_len + LHA.Size_c +2, 0);

     if ( add==SEARCH )
     if ( is_name(FileName) )
     {
	  close(in);
	  return 1;
     }
     if ( add==COLLECT )
     {
	  add_list( FileName, LHA.Size_o, ((long)Crc16) & 0x0FFFFL);
     }
  };
  close(in);
  return 0;
}

//---------------------------- ARJ support ---------------------------------

struct
{
  uchar  Method;
  uint   Filler1;
  ulong  Date_Time, Size_c, Size_o, Crc32;
  ulong  Filler2;
  uint   Filler3;
} ARJ;

// finds  a contents of .ARJ archive
int find_ARJ( char * arcName, int add )
{
   long filesize, SavePos;
   int Done;
   uchar I, Index, FileName[128+1];
   ulong sign;

   if (add==COLLECT) arcname=add_arcname( fname ); // store name of archive

   if (( in=open( arcName, O_RDONLY | O_BINARY ))<0 )
      return 0;

   filesize=lseek( in, 0, 2 );
   lseek( in, 2, 0 );  // skip the header

   Done = 0;

   sign = 0;
   while (!Done && lseek( in, 0, 1 ) < filesize )
   {
     SavePos = lseek( in, 0, 1 );
     sign >>= 8;
     read( in, ((char *)(&sign))+1, 1 );

     if (sign == 0x0EA60L)
     {
       read( in, &Index, 1 );
       if (Index != 0)
       {
	 lseek(in, SavePos + 8, 0);
         read( in, &ARJ, sizeof(ARJ));
	 I = 0;
	 do
	 {
           read( in, &FileName[I++], 1);
	 } while ( FileName[I-1] );

         if ( add==SEARCH )
         if ( is_name(FileName) )
         {
          close(in);
          return 1;
         }
         if ( add==COLLECT )
         {
             char *t;
             // cut off directory from filename
             if ((t=strrchr( FileName, '/')) != NULL)
                add_list( t+1, ARJ.Size_o, ARJ.Crc32);
             else
                add_list( FileName, ARJ.Size_o, ARJ.Crc32);
         }
         lseek( in, SavePos + ARJ.Size_c + Index + 9, 0);
       }
       else Done = 1;
     };
  };
  close(in);
  return 0;
}

//---------------------------- ZIP support ---------------------------------

struct
{
   uint    Version_Made_By;      // System id/program vers.
   uint    Version;              // Vers. needed to extract
   uint    BitFlag;              // General flags
   uint    Compression_Method;   // Compression type used
   uint    Time;                 // File creation time
   uint    Date;                 // File creation date
   ulong   Crc32;                // 32-bit CRC of file
   ulong   Size_c;               // Compressed size of file
   ulong   Size_o;               // Original size of file
   uint    FileName_Length;      // Length of file name
   uint    ExtraField_Length;    // Length of extra stuff
   uint    CommentField_Length;  // Length of comments
   uint    Diskstart_Number;     // Disk # file starts on
   uint    Internal_Attributes;  // Text/non-text flags
   ulong   External_Attributes;  // File system attributes
   ulong   LocalHeader_Offset;   // Where local hdr starts
} Zip_Central_Header;

struct
{
    uint  Version;                   // Vers. needed to extract
    uint  BitFlag;                   // General flags
    uint  Compression_Method;        // Compression type used
    uint  Time;                      // File creation time
    uint  Date;                      // File creation date
    ulong Crc32;                     // 32-bit CRC of file
    ulong Size_c;                    // Compressed size of file
    ulong Size_o;                    // Original size of file
    uint  FileName_Length;           // Length of file name
    uint  ExtraField_Length;         // Length of extra stuff
} Zip_Local_Header;

ulong
  Zip_Central_Header_Signature  = 0x02014B50,
  Zip_Local_Header_Signature    = 0x04034B50,
  Zip_End_Central_Dir_Signature = 0x06054B50;

// finds  a contents of .ZIP archive
int find_ZIP( char * arcName, int add )
{
   long filesize, SavePos;
   int Done;
   uchar FileName[128+1];
   ulong sign;

   if (add==COLLECT) arcname=add_arcname( fname ); // store name of archive

   if (( in=open( arcName, O_RDONLY | O_BINARY ))<0 )
      return 0;

   filesize=lseek( in, 0, 2 );
   lseek( in, 0, 0 );  // goto at header

   Done = 0;

   sign = 0;
   while (!Done && (lseek( in, 0, 1 ) < filesize) )
   {
     sign >>= 8;
     read( in, ((char *)(&sign))+3, 1 );

    if ((sign & 0xFFFF) == 0x4B50)
    switch ( sign >> 16)
    {
    case 0x0403: // Zip_Local_Header_Signature

	read( in, &Zip_Local_Header, sizeof(Zip_Local_Header));
	read( in, FileName, Zip_Local_Header.FileName_Length);
	FileName[ Zip_Local_Header.FileName_Length ]=0;
	lseek(in, Zip_Local_Header.Size_c, 1); // skip compressed part
	if ( add==COLLECT )
        {
            char *t;
            // cut off directory from filename
            if ((t=strrchr( FileName, '/')) != NULL)
               add_list( t+1, Zip_Local_Header.Size_o, Zip_Local_Header.Crc32);
            else
               add_list( FileName, Zip_Local_Header.Size_o, Zip_Local_Header.Crc32);
        }
	break;

    case 0x0201: // Zip_Central_Header_Signature
	read( in, &Zip_Central_Header, sizeof(Zip_Central_Header));
	read( in, FileName, Zip_Central_Header.FileName_Length);
	FileName[ Zip_Central_Header.FileName_Length ]=0;
	lseek(in, Zip_Central_Header.CommentField_Length +
		      Zip_Central_Header.ExtraField_Length, 1); // +current

	 if ( add==SEARCH )
	 if ( is_name(FileName) )
	 {
	  close(in);
	  return 1;
	 }
	break;
    case 0x0605: // Zip_End_Central_Dir_Signature
	Done = 1; // Skip dir information
    };
  };
  close(in);
  return 0;
}

//---------------------------- RAR support ---------------------------------

 struct
{
    uint  HEAD_CRC;    //   2 bytes     CRC of total block or block part
    uchar HEAD_TYPE;   //   1 byte      Block type
    uint  HEAD_FLAGS;  //   2 bytes     Block flags
    uint  HEAD_SIZE;   //   2 bytes     Block size
  //  ulong ADD_SIZE;       4 bytes     Optional field - added block size
} RARblk;

struct
{
	ulong UNP_SIZE; //      Uncompressed file size
	uchar HOST_OS;  //      Operating system used for archiving
	ulong FILE_CRC; //      File CRC
	ulong FTIME;    //      Date and time in standard MS DOS format
	uchar UNP_VER;  //      RAR version needed to extract file
	uchar METHOD;   //      Packing method
	uint  NAME_SIZE;//      File name size
	ulong ATTR;     //      File attributes
} RARfile;
// followed by FILE_NAME       File name - string of NAME_SIZE bytes size

// finds  a contents of .RAR archive
int find_RAR( char * arcName, int add )
{
   long filesize, addsize;
   int Done;
   uchar FileName[128+1];

   if (add==COLLECT) arcname=add_arcname( fname ); // store name of archive

   if (( in=open( arcName, O_RDONLY | O_BINARY ))<0 )
      return 0;

   filesize=lseek( in, 0, 2 );
   lseek( in, 0, 0 );  // seek the header

   Done = 0;

   while (!Done && lseek( in, 0, 1 ) < filesize )
   {
	addsize=0;
	read( in, &RARblk, sizeof(RARblk) );
	if ( RARblk.HEAD_FLAGS & 0x8000 )
	{
	    read( in, &addsize, sizeof(addsize) );
	    addsize -= 4;
	}
	switch ( RARblk.HEAD_TYPE )
	{
	    case 0x72: break;  // marker block
	    case 0x73: break;  // archive header
	    case 0x74:         // file header
		 read( in, &RARfile, sizeof(RARfile));
		 addsize -= sizeof(RARfile);
		 read( in, &FileName, RARfile.NAME_SIZE );
		 addsize -= RARfile.NAME_SIZE;
		 FileName[ RARfile.NAME_SIZE ]= 0;
		 if (( RARblk.HEAD_FLAGS & 0xE0 ) != 0xE0 )
                 {
                 if ( add==SEARCH )
		 if ( is_name(FileName) )
		 {
		  close(in);
		  return 1;
		 }
                 // don't add directory names into sorted list
                 if ( add==COLLECT && RARfile.ATTR != 0x010L)
                 {
                    char *t;
                    // cut off directory from filename
                    if ((t=strrchr( FileName, '\\')) != NULL)
                       add_list( t+1, RARfile.UNP_SIZE, RARfile.FILE_CRC);
                    else
                       add_list( FileName, RARfile.UNP_SIZE, RARfile.FILE_CRC);
                 }
                 }
		 break;  // file header
	    case 0x75: break;  // comment header
	    case 0x76: break;  // extra information
	    case 0x77: break;  // subblock
	    case 0x78: break;  // recovery record
	}
	lseek( in, RARblk.HEAD_SIZE+addsize-sizeof(RARblk), 1 );
  };
  close(in);
  return 0;
}

//---------------------------- HA support ---------------------------------

struct
{
        uchar ver;   // ver<<4 | type   /* type 0-CPY, 1-ASC, 2-HSC, 0xe-DIR 0xf-SPECIAL */
        ulong clen;  // length compressed
        ulong ulen;  // length original
        ulong crc32; // CRC 32
        ulong ftime; // filetime
} HAfile;

// finds  a contents of .HA archive
int find_HA( char * arcName, int add )
{
   long filesize, addsize;
   int Done;
   int files, machine;
   uchar FileName[128+1];
   int i;

   if (add==COLLECT) arcname=add_arcname( fname ); // store name of archive

   if (( in=open( arcName, O_RDONLY | O_BINARY ))<0 )
      return 0;

   filesize=lseek( in, 0, 2 );
   lseek( in, 0, 0 );  // seek the header

   read( in, FileName, 2 ); // signature
   if ( memcmp( FileName, "HA", 2 )) { close(in); return 0; }

   read( in, &files, 2 ); // total # of files

   while (files-- && lseek( in, 0, 1 ) < filesize )
   {
        read( in, &HAfile, sizeof(HAfile) ); // file header

        while ( lseek( in, 0, 1 ) < filesize ) // ASCIIZ path
        {
           read( in, FileName, 1 );
           if ( FileName[0]==0 ) break;
        }

        i=0;
        memset( FileName, 0, sizeof( FileName ));
        while ( i<120 && lseek( in, 0, 1 ) < filesize ) // ASCIIZ filename
        {
           read( in, &FileName[i++], 1 );
           if ( FileName[i-1]==0 ) break;
        }

        machine=0;
        read( in, &machine, 1 );
        lseek( in, (long) machine, 1); // skip over machine-specific info

        lseek( in, HAfile.clen, 1 ); // skip compressed part

        if ( add==SEARCH )
        if ( is_name(FileName) )
        {
         close(in);
         return 1;
        }
        if ( add==COLLECT )
        add_list( FileName, HAfile.ulen, HAfile.crc32);
  };
  close(in);
  return 0;
}

char run_cmd[512];

// do all job
void doit(long file_size)
{
    int i, j, t;

    int res=0, need_dir=0;

    if ( strstr( strupr(fname), ".RAR" ))
    {
       t = find_RAR( fname, SEARCH );
       if (t && mk_sort_list) find_RAR( fname, COLLECT );
       res += t;
    }
    if ( strstr( strupr(fname), ".HA" ))
    {
       t = find_HA( fname, SEARCH );
       if (t && mk_sort_list) find_HA( fname, COLLECT );
       res += t;
    }
    if ( strstr( strupr(fname), ".ZIP" ))
    {
       t = find_ZIP( fname, SEARCH );
       if (t && mk_sort_list) find_ZIP( fname, COLLECT );
       res += t;
    }
    if ( strstr( strupr(fname), ".ARJ" ))
    {
       t = find_ARJ( fname, SEARCH );
       if (t && mk_sort_list) find_ARJ( fname, COLLECT );
       res += t;
    }
    if ( strstr( strupr(fname), ".LZH" ))
    {
       t = find_LHA( fname, SEARCH );
       if (t && mk_sort_list) find_LHA( fname, COLLECT );
       res += t;
    }

    // import all another files in current dir
    if (!res && mk_sort_list && file_size)
    {
       long ocrc;
       char *t;
       // return true if Ok
       if (get_file_crc( fname, file_size, &ocrc ))
       // adds one file from current archive to sorted list
       {
          arcname=add_arcname( fname ); // store name of archive (same as file)
          if ((t=strrchr( fname, '\\')) != NULL)
              add_list( t+1, file_size, ocrc);
          else
              add_list( fname, file_size, ocrc);
       }
    }

    if ( !res ) return;

    if (ccommand[0]) // issue DOS command line
    {
       memset(run_cmd, 0, sizeof( run_cmd ));
       i=0; j=0;
       while ( i<strlen( ccommand ))
       {
	  run_cmd[j]=ccommand[i];

	  if (j>4) // we can test for &FNAME now
	  {
	     if (!memcmp( &run_cmd[j-5], "&FNAME", 6))
	     {
		 j-=5;
		 strcpy( &run_cmd[j], fname );
		 j += strlen(fname);
		 i++; continue;
	     }
	  }
	  if (j>3) // we can test for &NAME now
	  {
	     if (!memcmp( &run_cmd[j-4], "&NAME", 5))
	     {
		 need_dir=1;
		 j-=4;
		 strcpy( &run_cmd[j], oname );
		 j += strlen(oname);
		 i++; continue;
	     }
	  }
	  j++; i++;
       }
       if (need_dir && !no_mkdir) mkdir( oname );
       system( run_cmd );
    }
}

char cr_sign[]="inarch 1.0 CRC base\x1A";
char ar_sign[]="inarch 1.0 arcname base\x1A";

char TCorrupted[] = "file %s contain corrupted block\n";
char TIsnotDB[]   = "file %s is not an 'inarch database'\n";
char TBadData[]   = "file %s contain large (bad) file data\n";
char TCantImp[]   = "Cannot import from %s\n";

void import(void)
{
   char name[120];
   union
   { char buf[256];
     ITEM it;
   } x;

   int i, l_icount, l_arccount;
   uint size, size1;
   FILE *in;

   // first, read the archive names from base
   strcpy(name, bfilename);
   strcat(name, ".ar$");
   if ((in=fopen(name, "rb"))==NULL  )
   {
      printf( TCantImp, name);
      return;
   }

   fread( x.buf, 1, sizeof( ar_sign ), in );
   if ( memcmp( x.buf, ar_sign, sizeof( ar_sign ) ))
   {
      printf( TIsnotDB, name);
      fclose(in);
      return;
   }

   fread( &l_arccount, 1, 2, in );          // total
   for (i=0; i<l_arccount; i++)
   {
      fread( &size, 1, 2, in );         // size of next chunk
      if ( size>= sizeof(x.buf) )
      {
         printf( TBadData, name);
         fclose(in);
         exit(0);
      }
      fread( x.buf, 1, size, in );    // data itself
      x.buf[size]=0;
      fread( &size1, 1, 2, in );         // control mark
      if ( size != size1 )
      {
         printf( TCorrupted, name);
         fclose(in);
         exit(0);
      }
      add_arcname( x.buf );
   }
   fclose(in);




   strcpy(name, bfilename);
   strcat(name, ".cr$");
   if ((in=fopen(name, "rb"))==NULL  )
   {
      printf( TCantImp, name);
      exit(0);
   }

   fread( x.buf, 1, sizeof( cr_sign ), in );
   if ( memcmp( x.buf, cr_sign, sizeof( cr_sign ) ))
   {
      printf( TIsnotDB, name);
      fclose(in);
      exit(0);
   }

   fread( &l_icount, 1, 2, in );          // total
   for (i=0; i<l_icount; i++)
   {
      fread( &size, 1, 2, in );         // size of next chunk
      if ( size>= sizeof(x.buf) )
      {
         printf( TBadData, name);
         fclose(in);
         exit(0);
      }
      fread( x.buf, 1, size, in );    // data itself
      x.buf[size]=0; // last char of item.name
      fread( &size1, 1, 2, in );         // control mark
      if ( size != size1 )
      {
         printf( TCorrupted, name);
         fclose(in);
         exit(0);
      }
      arcname = x.it.arcname; // index of archive name in names list
      // adds one file from current archive to sorted list
      add_list( x.it.name, x.it.decomp_size, x.it.crc );

   }
   fclose(in);

   printf("file list is imported from '%s'\n", bfilename );
}

void export(void)
{
   char name[120];
   int i, size;
   FILE *out;

   strcpy(name, bfilename);
   strcat(name, ".cr$");
   if ((out=fopen(name, "wb"))==NULL  )
   {
      printf("Cannot export to %s\n", name);
      return;
   }

   fwrite( cr_sign, 1, sizeof( cr_sign ), out );
   fwrite( &icount, 1, 2, out );          // total
   for (i=0; i<icount; i++)
   {
      size= strlen( item[i]->name ) + sizeof(ITEM);
      fwrite( &size, 1, 2, out );         // size of next chunk
      fwrite( item[i], 1, size, out );    // data itself
      fwrite( &size, 1, 2, out );         // control mark
   }
   fclose(out);

   strcpy(name, bfilename);
   strcat(name, ".ar$");
   if ((out=fopen(name, "wb"))==NULL  )
   {
      printf("Cannot export to %s\n", name);
      return;
   }

   fwrite( ar_sign, 1, sizeof( ar_sign ), out );
   fwrite( &arccount, 1, 2, out );          // total
   for (i=0; i<arccount; i++)
   {
      size= strlen( arcnames[i] ) + 1;
      fwrite( &size, 1, 2, out );         // size of next chunk
      fwrite( arcnames[i], 1, size, out );    // data itself
      fwrite( &size, 1, 2, out );         // control mark
   }
   fclose(out);
   printf("file list is exported to '%s'\n", bfilename );
}

void main(int argc, char *argv[])    // 室 pp
{
    struct ffblk ffblk;
    int i, done;
    char *t;

    if (argc < 3) { printf(
	"\nIn-archive-Finder ver. %s (c) Milukov A.\n"\
	"usage: %s file options\n\n"\
	"file - is a filename of archive (known as .HA .ARJ .ZIP .RAR .LHA)\n"\
	"\tin which to search, wildcard (?,*) is Ok\n"\
	"options - is a set of hyphen-separated optional strings\n"\
	"\npress any key...\n",
	__DATE__, argv[0] );
	getchar();

	printf(
	"-ebfile    export list of scanned file(s) to bfile.cr$ and bfile.ar$\n"\
	"           for future use with 'import mode' in another directory\n"\
	"-ibfile    import list of scanned file(s) from bfile.cr$ and bfile.ar$\n"\
	"           both should be made by InArch 'export mode'\n"\
	"           allows You to compare the different drives etc.\n"\
	"NOTE:      -e and -i works only with '-sort' options\n\n"\
	"-sort      make list of all file(s) in all found archives,\n"\
	"           sorted by decomp.size and CRC-32 (in that order)\n"\
	"           note: all supported archivers use the same crc method\n"\
	"-nomd      don't call mkdir() if &NAME was used in DOS command\n"\
	"-ffilename check if filename present in archive, '*.*' by default\n"\
	"\npress any key...\n");
	getchar();

	printf(
	"-ccommand  the DOS command to run if filename present in archive\n\n"\
	"command can contain (must be double-quoted if includes '|' or '>'):\n"\
	"\t&FNAME token to substitute a full archive pathname with ext\n"\
	"\t&NAME to substitute only archive name (no path nor extension)\n\n"\
	"EXAMPLE: inarch *.zip -ffile_id.diz \"-cpkunzip &FNAME &NAME\\ *.exe\"\n"\
	"will extract all *.exe files from .ZIP archives if they \n"\
	"contain 'file_id.diz' files into the same-named directories.\n\n");
	printf("NOTE: since LHA has CRC-16 code that differs from\n"
	       "      the one used in another archiver's,\n"
	       "      You MUST be VERY CAREFULL in case of .lzh file(s) !\n");
	exit(0);
    };

    ccommand[0]=0;
    strcpy( ffilename, "*.*"); // default

    for (i=2; i<argc; i++)
    {
       if (!memcmp(argv[i],"-f",2))
       {
	  strcpy( ffilename, &argv[i][2] );
	  continue;
       }
       if (!memcmp(argv[i],"-c",2))
       {
	  strcpy( ccommand, &argv[i][2] );
	  printf("command: '%s'\n", ccommand );
	  continue;
       }
       if (!memcmp(argv[i],"-sort",5))
       {
          mk_sort_list=1;
	  continue;
       }
       if (!strcmp(argv[i],"-nomd"))
       {
	  no_mkdir=1;
	  printf("Mkdir() disabled\n");
	  continue;
       }
       if (!memcmp(argv[i],"-e",2) && import_f==0)
       {
          export_f=1;
          strcpy( bfilename, &argv[i][2] );
	  continue;
       }
       if (!memcmp(argv[i],"-i",2) && export_f==0)
       {
          import_f=1;
          strcpy( bfilename, &argv[i][2] );
	  continue;
       }
    }


    if ( mk_sort_list )
    {
       makecrctab();
       arcnames=(LPSTR *)farmalloc( MAX_ARCS * sizeof(char far *));
       if ( arcnames==(LPSTR *)NULL )
       {
          printf("malloc() failure\n"); exit(0);
       }
       memset( arcnames, 0, MAX_ARCS * sizeof(char far *));

       if ( import_f ) import();
    }

    printf("looking for \"%s\"\n", ffilename );
    getcurdir( 0, oname /* temp storage */ );
    sprintf(curdir, "%c:\\%s", 'A'+getdisk(), oname );

    curdirend = strlen(curdir);
    if (curdirend)
    if (curdir[curdirend-1] != '\\')
    strcat( curdir, "\\");
    curdirend = strlen(curdir); // points to \0 after the last '\' of path


    done = findfirst( argv[1] , &ffblk,0);
    while (!done)
    {
       saveDTA = getdta();
       setdta( newDTA );

       // build full filename with path
       strcpy( fname, curdir );
       strcat( fname, ffblk.ff_name );

       // build name only
       strcpy( oname, ffblk.ff_name );
       // find last point (dot) and cut it
       if ((t=strrchr( oname, '.')) != NULL) *t = 0;

       printf("%s\n", fname);
       doit( ffblk.ff_fsize );

       setdta( saveDTA );
       done = findnext(&ffblk);
    }

   if ( mk_sort_list )
   {
      report();
   }
   exit(0);
}
